#define potentiometer  A0

#define echopin 11 // echo pin
#define trigpin 12  // Trigger pin

int read_pot =0;
unsigned long set_time =0;
unsigned long rememTime;

float distance_cm;
unsigned long ultra_time;
int set_cm = 20;
int motor = 2; // Output for Motor drive
int flag=0;

void setup(){
Serial.begin(9600);// initialize serial communication at 9600 bits per second:

pinMode(potentiometer, INPUT);

pinMode (trigpin, OUTPUT);
pinMode (echopin, INPUT);

pinMode(motor, OUTPUT); 

delay(200); // Waiting for a while
}

void loop(){ 

ultrasonicRead();

read_pot = analogRead(potentiometer);
set_time = map(read_pot, 0, 1023, 500UL, 6000UL);
/* By default an integer const is treated as an int with the limitations in values
 *  to specify an integer constant with another data type follow it with UL
 *  to force the constant into an unsigned long constant
 */
Serial.print("Distance :");
Serial.println(distance_cm); 
Serial.print("Time:");
Serial.println(set_time); 


if(distance_cm<set_cm && flag==0)
{

digitalWrite(motor,HIGH);
Serial.println("Motor On");
rememTime = millis();
flag=1; 
/*value returned by millis() is the amount of time that has passed since the Arduino board was powered up
 * to store millis() to a variable unsigned long 32 bits Data type is used 0 - 4,294,967,295
 * millis() return only positive value so use unsigned
 when used in calculations raw numbers should have UL formatter at the end */
}

if(distance_cm > set_cm)
{
  flag=0;
}

if((millis()- rememTime) > set_time)
{   
digitalWrite(motor,LOW);
Serial.println("Motor Off");
}
delay(100); 
}


void ultrasonicRead()
{
digitalWrite(trigpin, LOW);
delayMicroseconds(2);
digitalWrite(trigpin, HIGH);
delayMicroseconds(10);
ultra_time = pulseIn (echopin, HIGH);
distance_cm =  ultra_time / 29 / 2; 
}
